//------------------------------------------------------------------
// not for sale, rent, auction, nor lease
// 2020
#property copyright "www.forex-station.com"
#property link      "www.forex-station.com"
#property description "not for sale, rent, auction, nor lease\nDisplay 6 different RCI"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 12

#property indicator_color11 C'0,200,0'
#property indicator_color12  clrRed 

#property indicator_color9  C'0,180,0'
#property indicator_color10  clrCrimson

#property indicator_color7  C'0,160,0'
#property indicator_color8 C'154,5,39'

#property indicator_color5  C'0,140,0'
#property indicator_color6 C'144,5,39'

#property indicator_color3  C'0,120,0'
#property indicator_color4 C'134,5,39'
#property indicator_color1  C'0,100,0' //clrDarkGreen
#property indicator_color2 C'124,5,39'

#property indicator_minimum 0
#property indicator_maximum 7


extern string TimeFrame1            = "Current time frame";
extern string UniqueID              = "6x RCI";
extern int    HowManyBarsToDisplay  = 100;
extern int    RCIperiod1            = 50; //was 9
extern int    RCIperiod2            = 54; //was 26
extern int    RCIperiod3            = 58; //was 52
extern int    RCIperiod4            = 62; 
extern int    RCIperiod5            = 75; 
extern int    RCIperiod6            = 89; 
extern int    WingdingsFontSymbol1  = 110;
extern int    WingdingsFontSymbol2  = 110;
extern int    WingdingsFontSymbol3  = 110;
extern int    WingdingsFontSymbol4  = 108;
extern int    WingdingsFontSymbol5  = 108;
extern int    WingdingsFontSymbol6  = 108;
extern int    LinesWidth            =  0;
extern color  LabelsColor           = clrBrown;
extern int    LabelsHorizontalShift = 5;
extern double LabelsVerticalShift   = 1.5;
extern bool   alertsOn              = false;
extern int    alertsLevel           = 6;
extern bool   alertsMessage         = false;
extern bool   alertsSound           = false;
extern bool   alertsEmail           = false;
extern bool   alertsOnEachBar       = false;
extern string note_a="input an integer for TimeFrame1 such as";
extern string note_b="1,5,15,30,60,240,1440,10080,43200, or leave as it is";

double myRCI1up[], myRCI1down[], myRCI2up[], myRCI2down[], myRCI3up[], myRCI3down[], myRCI4up[], myRCI4down[], myRCI5up[], myRCI5down[], myRCI6up[], myRCI6down[];

int    timeFrames[6];
bool   returnBars;
string indicatorFileName;
//------------------------------------------------------------------
int OnInit()
{
      SetIndexBuffer(0,myRCI1up);
      SetIndexBuffer(1,myRCI1down);
      SetIndexBuffer(2,myRCI2up);
      SetIndexBuffer(3,myRCI2down);
      SetIndexBuffer(4,myRCI3up);
      SetIndexBuffer(5,myRCI3down);
      SetIndexBuffer(6,myRCI4up);
      SetIndexBuffer(7,myRCI4down);
      SetIndexBuffer(8,myRCI5up);
      SetIndexBuffer(9,myRCI5down);
      SetIndexBuffer(10,myRCI6up);
      SetIndexBuffer(11,myRCI6down);

      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame1=="returnBars"); if (returnBars) return(0);
      
      for (int i=0; i<12; i++) 
         SetIndexStyle(i,DRAW_ARROW,EMPTY,LinesWidth);  

      SetIndexArrow(0,WingdingsFontSymbol1);
      SetIndexArrow(1,WingdingsFontSymbol1);
      SetIndexArrow(2,WingdingsFontSymbol2);
      SetIndexArrow(3,WingdingsFontSymbol2);
      SetIndexArrow(4,WingdingsFontSymbol3);
      SetIndexArrow(5,WingdingsFontSymbol3);
      SetIndexArrow(6,WingdingsFontSymbol4);
      SetIndexArrow(7,WingdingsFontSymbol4);     
      SetIndexArrow(8,WingdingsFontSymbol5);
      SetIndexArrow(9,WingdingsFontSymbol5);
      SetIndexArrow(10,WingdingsFontSymbol6);
      SetIndexArrow(11,WingdingsFontSymbol6);

      for (int babyYoda =0; babyYoda <6; babyYoda++)
      timeFrames[babyYoda] = stringToTimeFrame(TimeFrame1);

      alertsLevel = MathMin(MathMax(alertsLevel,5),6);
      IndicatorShortName(UniqueID);
   return(0);
}
//+-------------------------------------------------------------------
int deinit()
{
   for (int t=0; t<6; t++) ObjectDelete(UniqueID+t);
   return(0); 
}
//------------------------------------------------------------------
double trend[][2];
#define _up 0
#define _dn 1
int start()
{
         int i,r,counted_bars=IndicatorCounted();
   
         if(counted_bars < 0) return(-1);
         if(counted_bars>0) counted_bars--;
//         int limit = MathMin(Bars-counted_bars,Bars-1);
         int limit = HowManyBarsToDisplay;
         if (returnBars) { myRCI1up[0] = limit+1; return(0); }

         if (timeFrames[0] != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[0],indicatorFileName,"returnBars",0,0)*timeFrames[0]/Period()));
         if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
        
         bool initialized = false;
         if (!initialized)
         {
               initialized = true;
               int window = WindowFind(UniqueID);

               string label1 = timeFrameToString (timeFrames[0]) + " (" + IntegerToString(RCIperiod1) + ")";
               ObjectCreate (UniqueID+0,OBJ_TEXT,window,0,0);
               ObjectSet    (UniqueID+0,OBJPROP_COLOR,LabelsColor);
               ObjectSet    (UniqueID+0,OBJPROP_PRICE1,0+LabelsVerticalShift);
               ObjectSetText(UniqueID+0,label1,7,"Arial");
               ObjectSet    (UniqueID+0,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

               string label2 = timeFrameToString (timeFrames[1]) + " (" + IntegerToString(RCIperiod2) + ")";
               ObjectCreate(UniqueID+1,OBJ_TEXT,window,0,0);
               ObjectSet(UniqueID+1,OBJPROP_COLOR,LabelsColor);
               ObjectSet(UniqueID+1,OBJPROP_PRICE1,1+LabelsVerticalShift);
               ObjectSetText(UniqueID+1,label2,7,"Arial");
               ObjectSet(UniqueID+1,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

               string label3 = timeFrameToString (timeFrames[2]) + " (" + IntegerToString(RCIperiod3) + ")";
               ObjectCreate(UniqueID+2,OBJ_TEXT,window,0,0);
               ObjectSet(UniqueID+2,OBJPROP_COLOR,LabelsColor);
               ObjectSet(UniqueID+2,OBJPROP_PRICE1,2+LabelsVerticalShift);
               ObjectSetText(UniqueID+2,label3,7,"Arial");
               ObjectSet(UniqueID+2,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

               string label4 = timeFrameToString (timeFrames[3]) + " (" + IntegerToString(RCIperiod4) + ")";
               ObjectCreate(UniqueID+3,OBJ_TEXT,window,0,0);
               ObjectSet(UniqueID+3,OBJPROP_COLOR,LabelsColor);
               ObjectSet(UniqueID+3,OBJPROP_PRICE1,3+LabelsVerticalShift);
               ObjectSetText(UniqueID+3,label4,7,"Arial");
               ObjectSet(UniqueID+3,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

               string label5 = timeFrameToString (timeFrames[4]) + " (" + IntegerToString(RCIperiod5) + ")";
               ObjectCreate(UniqueID+4,OBJ_TEXT,window,0,0);
               ObjectSet(UniqueID+4,OBJPROP_COLOR,LabelsColor);
               ObjectSet(UniqueID+4,OBJPROP_PRICE1,4+LabelsVerticalShift);
               ObjectSetText(UniqueID+4,label5,7,"Arial");
               ObjectSet(UniqueID+4,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);

               string label6 = timeFrameToString (timeFrames[5]) + " (" + IntegerToString(RCIperiod6) + ")";
               ObjectCreate(UniqueID+5,OBJ_TEXT,window,0,0);
               ObjectSet(UniqueID+5,OBJPROP_COLOR,LabelsColor);
               ObjectSet(UniqueID+5,OBJPROP_PRICE1,5+LabelsVerticalShift);
               ObjectSetText(UniqueID+5,label6,7,"Arial");
               ObjectSet(UniqueID+5,OBJPROP_TIME1,Time[0]+Period()*LabelsHorizontalShift*60);
         } //if (!initialized)
   
   for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   {
      trend[r][_up] = 0;
      trend[r][_dn] = 0;
      for (int k=0; k<6; k++)
      {
            int y = iBarShift(NULL,timeFrames[k],Time[i]);
            //double iRCI(const string symbol, int timeframe, int period, int index)
            double yourRCI1 = iRCI(NULL,timeFrames[k],RCIperiod1,y);
            double yourRCI2 = iRCI(NULL,timeFrames[k],RCIperiod1,y+1);
            bool isUp1 = (yourRCI1>yourRCI2);

            double yourRCI3 = iRCI(NULL,timeFrames[k],RCIperiod2,y);
            double yourRCI4 = iRCI(NULL,timeFrames[k],RCIperiod2,y+1);
            bool isUp2 = (yourRCI3>yourRCI4);
            
            double yourRCI5 = iRCI(NULL,timeFrames[k],RCIperiod3,y);
            double yourRCI6 = iRCI(NULL,timeFrames[k],RCIperiod3,y+1);
            bool isUp3 = (yourRCI5>yourRCI6);
            
            double yourRCI7 = iRCI(NULL,timeFrames[k],RCIperiod4,y);
            double yourRCI8 = iRCI(NULL,timeFrames[k],RCIperiod4,y+1);
            bool isUp4 = (yourRCI7>yourRCI8);
            
            double yourRCI9 = iRCI(NULL,timeFrames[k],RCIperiod5,y);
            double yourRCI10 = iRCI(NULL,timeFrames[k],RCIperiod5,y+1);
            bool isUp5 = (yourRCI9>yourRCI10);
            
            double yourRCI11 = iRCI(NULL,timeFrames[k],RCIperiod6,y);
            double yourRCI12 = iRCI(NULL,timeFrames[k],RCIperiod6,y+1);
            bool isUp6 = (yourRCI11>yourRCI12);
            
            switch (k)
            {
               case 0 : if (isUp1) { myRCI1up[i] = k+1; myRCI1down[i] = EMPTY_VALUE;}  else { myRCI1down[i] = k+1; myRCI1up[i] = EMPTY_VALUE; } break;
               case 1 : if (isUp2) { myRCI2up[i] = k+1; myRCI2down[i] = EMPTY_VALUE;}  else { myRCI2down[i] = k+1; myRCI2up[i] = EMPTY_VALUE; } break;
               case 2 : if (isUp3) { myRCI3up[i] = k+1; myRCI3down[i] = EMPTY_VALUE;}  else { myRCI3down[i] = k+1; myRCI3up[i] = EMPTY_VALUE; } break;
               case 3 : if (isUp4) { myRCI4up[i] = k+1; myRCI4down[i] = EMPTY_VALUE;}  else { myRCI4down[i] = k+1; myRCI4up[i] = EMPTY_VALUE; } break;
               case 4 : if (isUp5) { myRCI5up[i] = k+1; myRCI5down[i] = EMPTY_VALUE;}  else { myRCI5down[i] = k+1; myRCI5up[i] = EMPTY_VALUE; } break;
               case 5 : if (isUp6) { myRCI6up[i] = k+1; myRCI6down[i] = EMPTY_VALUE;}  else { myRCI6down[i] = k+1; myRCI6up[i] = EMPTY_VALUE; } break;
            } //switch (k)
            if (isUp1)
                  trend[r][_up] += 1;
            else  trend[r][_dn] += 1;
      } //for (int k=0; k<6; k++)
   } //for(i = limit, r=Bars-i-1; i >= 0; i--,r++)
   manageAlerts();
   return(0);
} //int start()
//+-------------------------------------------------------------------
void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = Bars-1;
      if (trend[whichBar][_up] >= alertsLevel || trend[whichBar][_dn] >= alertsLevel)
      {
         if (trend[whichBar][_up] >= alertsLevel) doAlert("up"  ,trend[whichBar][_up]);
         if (trend[whichBar][_dn] >= alertsLevel) doAlert("down",trend[whichBar][_dn]);
      }
   }
}
//+-------------------------------------------------------------------
void doAlert(string doWhat, int howMany)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || (alertsOnEachBar && previousTime != Time[0])) 
   {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" "+howMany+" time frames of stochastic are aligned "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" 8x Stochastic",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
//-------------------------------------------------------------------
string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int toInt(double value) { return(value); }
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   int max = ArraySize(iTfTable)-1, add=0;
   int nxt = (StringFind(tfs,"NEXT1")>-1); if (nxt>0) { tfs = ""+Period(); add=1; }
       nxt = (StringFind(tfs,"NEXT2")>-1); if (nxt>0) { tfs = ""+Period(); add=2; }
       nxt = (StringFind(tfs,"NEXT3")>-1); if (nxt>0) { tfs = ""+Period(); add=3; }
       nxt = (StringFind(tfs,"NEXT4")>-1); if (nxt>0) { tfs = ""+Period(); add=4; }
         
      for (int i=max; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[toInt(MathMin(max,i+add))],Period()));
                                                      return(Period());
}
//+-------------------------------------------------------------------
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
//+-------------------------------------------------------------------
string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int xchar = StringGetChar(s, length);
         if((xchar > 96 && xchar < 123) || (xchar > 223 && xchar < 256))
                     s = StringSetChar(s, length, xchar - 32);
         else if(xchar > -33 && xchar < 0)
                     s = StringSetChar(s, length, xchar + 224);
   }
   return(s);
}
//+-------------------------------------------------------------------
//https://qiita.com/bucchi49/items/a08f240b920fc5f90a87
double iRCI(const string symbol, int timeframe, int period, int index)
{   
    int rank;
    double d = 0;
    double close_arr[];
    ArrayResize(close_arr, period); 

    for (int i = 0; i < period; i++) {
        close_arr[i] = iClose(symbol, timeframe, index + i);
    }

    ArraySort(close_arr, WHOLE_ARRAY, 0, MODE_DESCEND);

    for (int j = 0; j < period; j++) {
        rank = ArrayBsearch(close_arr,
                            iClose(symbol, timeframe, index + j),
                            WHOLE_ARRAY,
                            0,
                            MODE_DESCEND);
        d += MathPow(j - rank, 2);
    }

    return((1 - 6 * d / (period * (period * period - 1))) * 100);
}
//+-------------------------------------------------------------------
